#!/usr/bin/perl
if ($ARGV[0] eq '')
{
    print "Please give script arguments (e.g., ./Module_seed_match_conservation_Drosophilids.pl Conserved_Family_Info.txt).\n";
}
else
{
    open(ANNOT,$ARGV[0]);
    @lines=<ANNOT>;
    close(ANNOT);
    foreach $line (@lines)
    {
	$line=~s/\n//;
#	if ($line !~ /^miR Family\tGene Symbol\tGene Tax ID\tUTR start\tUTR end\tMSA start\tMSA end\tSeed match$/)
#	{
	    ($miR,$gene,$species,$start,$end)=($line,$line,$line,$line,$line);
	    $miR=~s/ .*//;
	    $gene=~s/^$miR (\S*) .*/\1/;
	    $species=~s/^$miR \S* (\d*) .*/\1/;
	    $start=~s/^$miR \S* $species \d* \d* (\d*) .*/\1/;
	    $end=~s/^$miR \S* $species \d* \d* $start (\d*) .*/\1/;

	    $seen=0;
	    for ($i=0;$i<$n;++$i)
	    {
		if (($miR eq $miRs[$i]) && ($gene eq $genes[$i]) && ( (($start >= $starts[$i]) && ($start <= $ends[$i])) || (($end >= $starts[$i]) && ($end <= $ends[$i])) || (($start <= $starts[$i]) && ($end >= $ends[$i])) ))
		{
		    $organisms[$i]=$organisms[$i]." ".$species;
		    $seen=1;
		}
	    }
	    if ($seen == 0)
	    {
		push(@miRs,$miR);
		push(@genes,$gene);
		push(@starts,$start);
		push(@ends,$end);
		$n=push(@organisms,$species);
	    }
#	}
    }

#    open(OUTPUT,"> conservation_$ARGV[0]");
    for ($i=0;$i<$n;++$i)
    {
#	print OUTPUT "$genes[$i] $miRs[$i] $starts[$i]-$ends[$i]; species: $organisms[$i]\n";
	print "$genes[$i] $miRs[$i] $starts[$i]-$ends[$i]; species: $organisms[$i]\n";

    }
#    close(OUTPUT);
}
